diff --git a/src/tools/msvc/Solution.pm b/src/tools/msvc/Solution.pm
index 714585f..764ba1e 100644
--- a/src/tools/msvc/Solution.pm
+++ b/src/tools/msvc/Solution.pm
@@ -25,11 +25,18 @@ sub _new
 		platform                   => undef, };
 	bless($self, $classname);
 
+	$self->DeterminePlatform();
+	my $bits = $self->{platform} eq 'Win32' ? 32 : 64;
+
 	# integer_datetimes is now the default
 	$options->{integer_datetimes} = 1
 	  unless exists $options->{integer_datetimes};
 	$options->{float4byval} = 1
 	  unless exists $options->{float4byval};
+	$options->{float8byval} = ($bits == 64)
+	  unless exists $options->{float8byval};
+	die "float8byval not permitted on 32 bit platforms"
+	  if  $options->{float8byval} && $bits == 32;
 	if ($options->{xml})
 	{
 		if (!($options->{xslt} && $options->{iconv}))
@@ -56,8 +63,6 @@ sub _new
 	die "Bad wal_segsize $options->{wal_segsize}"
 	  unless grep { $_ == $options->{wal_segsize} } (1, 2, 4, 8, 16, 32, 64);
 
-	$self->DeterminePlatform();
-
 	return $self;
 }
 
diff --git a/src/tools/msvc/config_default.pl b/src/tools/msvc/config_default.pl
index e4d4810..0bee0c0 100644
--- a/src/tools/msvc/config_default.pl
+++ b/src/tools/msvc/config_default.pl
@@ -6,7 +6,10 @@ our $config = {
 	asserts => 0,    # --enable-cassert
 	  # integer_datetimes=>1,   # --enable-integer-datetimes - on is now default
 	  # float4byval=>1,         # --disable-float4-byval, on by default
-	  # float8byval=>0,         # --disable-float8-byval, off by default
+
+	  # float8byval=> $platformbits == 64, # --disable-float8-byval,
+	  # off by default on 32 bit platforms, on by default on 64 bit platforms
+
 	  # blocksize => 8,         # --with-blocksize, 8kB by default
 	  # wal_blocksize => 8,     # --with-wal-blocksize, 8kB by default
 	  # wal_segsize => 16,      # --with-wal-segsize, 16MB by default
